Index: /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_mpi_transfert.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_mpi_transfert.F90	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_mpi_transfert.F90	(revision 1001)
@@ -1785,12 +1242,12 @@
     INTEGER,INTENT(IN) :: nb
     
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
     INTEGER :: ierr
 
-    IF (.not.is_ok_mpi) RETURN
-    
-#ifdef CPP_PARA
+    IF (.not.is_using_mpi) RETURN
+    
+#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_CHARACTER,mpi_root_x,COMM_LMDZ_PHY,ierr)
 #endif
@@ -1807,12 +1264,12 @@
     INTEGER,INTENT(IN) :: nb
     
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
     INTEGER :: ierr
 
-    IF (.not.is_ok_mpi) RETURN
-
-#ifdef CPP_PARA
+    IF (.not.is_using_mpi) RETURN
+
+#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_INTEGER,mpi_root_x,COMM_LMDZ_PHY,ierr)
 #endif
@@ -1830,12 +1287,12 @@
     INTEGER,INTENT(IN) :: nb
     
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
     INTEGER :: ierr
 
-    IF (.not.is_ok_mpi) RETURN
-
-#ifdef CPP_PARA
+    IF (.not.is_using_mpi) RETURN
+
+#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_REAL_LMDZ,mpi_root_x,COMM_LMDZ_PHY,ierr)
 #endif
@@ -1853,12 +1310,12 @@
     INTEGER,INTENT(IN) :: nb
     
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
     INTEGER :: ierr
 
-    IF (.not.is_ok_mpi) RETURN
-
-#ifdef CPP_PARA
+    IF (.not.is_using_mpi) RETURN
+
+#ifdef CPP_MPI
     CALL MPI_BCAST(Var,nb,MPI_LOGICAL,mpi_root_x,COMM_LMDZ_PHY,ierr)
 #endif
@@ -1877,5 +1334,5 @@
     INTEGER,INTENT(OUT),DIMENSION(klon_mpi,dimsize) :: VarOut
   
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -1887,5 +1344,5 @@
 
 
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:,:)=VarIn(:,:)
       RETURN
@@ -1906,5 +1363,5 @@
     ENDIF
       
-#ifdef CPP_PARA 
+#ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_INTEGER,VarOut,klon_mpi*dimsize,   &
                       MPI_INTEGER,mpi_root_x, COMM_LMDZ_PHY,ierr)
@@ -1922,5 +1379,5 @@
     REAL,INTENT(OUT),DIMENSION(klon_mpi,dimsize) :: VarOut
   
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -1932,5 +1389,5 @@
     INTEGER :: ierr
 
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:,:)=VarIn(:,:)
       RETURN
@@ -1950,5 +1407,5 @@
     ENDIF
       
-#ifdef CPP_PARA 
+#ifdef CPP_MPI 
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_REAL_LMDZ,VarOut,klon_mpi*dimsize,   &
                       MPI_REAL_LMDZ,mpi_root_x, COMM_LMDZ_PHY,ierr)
@@ -1968,5 +1425,5 @@
     LOGICAL,INTENT(OUT),DIMENSION(klon_mpi,dimsize) :: VarOut
   
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -1978,5 +1435,5 @@
     INTEGER :: ierr
 
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:,:)=VarIn(:,:)
       RETURN
@@ -1996,5 +1453,5 @@
     ENDIF
       
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     CALL MPI_SCATTERV(VarTmp,counts,displs,MPI_LOGICAL,VarOut,klon_mpi*dimsize,   &
                       MPI_LOGICAL,mpi_root_x, COMM_LMDZ_PHY,ierr)
@@ -2011,5 +1468,5 @@
     IMPLICIT NONE
   
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -2025,5 +1482,5 @@
     INTEGER :: ierr
 
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:,:)=VarIn(:,:)
       RETURN
@@ -2041,5 +1498,5 @@
     ENDIF
     
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_INTEGER,VarTmp,counts,displs,   &
                      MPI_INTEGER,mpi_root_x, COMM_LMDZ_PHY,ierr)
@@ -2065,5 +1522,5 @@
     IMPLICIT NONE
   
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -2089,10 +1546,10 @@
     ENDIF
     
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:,:)=VarIn(:,:)
       RETURN
     ENDIF
 
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_REAL_LMDZ,VarTmp,counts,displs,   &
                       MPI_REAL_LMDZ,mpi_root_x, COMM_LMDZ_PHY,ierr)
@@ -2121,5 +1578,5 @@
     LOGICAL,INTENT(OUT),DIMENSION(klon_glo,dimsize) :: VarOut
   
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -2131,5 +1588,5 @@
     INTEGER :: ierr
     
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:,:)=VarIn(:,:)
       RETURN
@@ -2147,5 +1604,5 @@
     
 
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     CALL MPI_GATHERV(VarIn,klon_mpi*dimsize,MPI_LOGICAL,VarTmp,counts,displs,   &
                       MPI_LOGICAL,mpi_root_x, COMM_LMDZ_PHY,ierr)
@@ -2172,5 +1629,5 @@
     IMPLICIT NONE
     
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -2181,5 +1638,5 @@
     INTEGER :: ierr
    
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:)=VarIn(:)
       RETURN
@@ -2187,5 +1644,5 @@
 
 
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_INTEGER,MPI_SUM,mpi_root_x,COMM_LMDZ_PHY,ierr)
 #endif
@@ -2199,5 +1656,5 @@
     IMPLICIT NONE
 
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     INCLUDE 'mpif.h'
 #endif
@@ -2208,10 +1665,10 @@
     INTEGER :: ierr
  
-    IF (.not.is_ok_mpi) THEN
+    IF (.not.is_using_mpi) THEN
       VarOut(:)=VarIn(:)
       RETURN
     ENDIF
    
-#ifdef CPP_PARA
+#ifdef CPP_MPI
     CALL MPI_REDUCE(VarIn,VarOut,nb,MPI_REAL_LMDZ,MPI_SUM,mpi_root_x,COMM_LMDZ_PHY,ierr)
 #endif
@@ -2443,2 +1900,3 @@
   END SUBROUTINE grid2dTo1d_mpi_lgen   
 
+END MODULE mod_phys_lmdz_mpi_transfert
Index: /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_data.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_data.F90	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_data.F90	(revision 1001)
@@ -7,5 +7,5 @@
   INTEGER,SAVE :: omp_rank
   LOGICAL,SAVE :: is_omp_root
-  LOGICAL,SAVE :: is_ok_omp
+  LOGICAL,SAVE :: is_using_omp
   
   INTEGER,SAVE,DIMENSION(:),ALLOCATABLE :: klon_omp_para_nb
@@ -27,5 +27,5 @@
     INTEGER :: i
 
-#ifdef _OPENMP    
+#ifdef CPP_OMP    
     INTEGER :: OMP_GET_NUM_THREADS
     EXTERNAL OMP_GET_NUM_THREADS
@@ -34,12 +34,12 @@
 #endif  
 
-#ifdef _OPENMP
+#ifdef CPP_OMP
 !$OMP MASTER
-        is_ok_omp=.TRUE.
+        is_using_omp=.TRUE.
         omp_size=OMP_GET_NUM_THREADS()
 !$OMP END MASTER
         omp_rank=OMP_GET_THREAD_NUM()    
 #else    
-    is_ok_omp=.FALSE.
+    is_using_omp=.FALSE.
     omp_size=1
     omp_rank=0
Index: /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_transfert.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_transfert.F90	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/mod_phys_lmdz_omp_transfert.F90	(revision 1001)
@@ -4,6 +4,20 @@
 MODULE mod_phys_lmdz_omp_transfert
 
-  INTEGER,PARAMETER :: omp_buffer_size = 1024*1024*16
-  INTEGER,SAVE,DIMENSION(omp_buffer_size) :: omp_buffer
+  PRIVATE
+  
+  INTEGER,PARAMETER :: grow_factor=1.5
+  INTEGER,PARAMETER :: size_min=1024
+  
+  CHARACTER(LEN=size_min),SAVE            :: buffer_c
+  INTEGER,SAVE                            :: size_c
+  INTEGER,SAVE,ALLOCATABLE,DIMENSION(:)   :: buffer_i
+  INTEGER,SAVE                            :: size_i
+  REAL,SAVE,ALLOCATABLE,DIMENSION(:)      :: buffer_r
+  INTEGER,SAVE                            :: size_r
+  LOGICAL,SAVE,ALLOCATABLE,DIMENSION(:)   :: buffer_l
+  INTEGER,SAVE                            :: size_l
+
+
+  
   
   INTERFACE bcast_omp
@@ -33,6 +47,57 @@
   END INTERFACE 
 
+
+  PUBLIC bcast_omp,scatter_omp,gather_omp,reduce_sum_omp
+
 CONTAINS
 
+  SUBROUTINE check_buffer_i(buff_size)
+  IMPLICIT NONE
+  INTEGER :: buff_size
+
+    IF (buff_size>size_i) THEN
+!$OMP BARRIER
+!$OMP MASTER
+      IF (ALLOCATED(buffer_i)) DEALLOCATE(buffer_i)
+      size_i=MAX(size_min,INT(grow_factor*buff_size))
+      ALLOCATE(buffer_i(size_i))
+!$OMP END MASTER
+!$OMP BARRIER
+    ENDIF
+  
+  END SUBROUTINE check_buffer_i
+  
+  SUBROUTINE check_buffer_r(buff_size)
+  IMPLICIT NONE
+  INTEGER :: buff_size
+
+    IF (buff_size>size_r) THEN
+!$OMP BARRIER
+!$OMP MASTER
+      IF (ALLOCATED(buffer_r)) DEALLOCATE(buffer_r)
+      size_r=MAX(size_min,INT(grow_factor*buff_size))
+      ALLOCATE(buffer_r(size_r))
+!$OMP END MASTER
+!$OMP BARRIER
+    ENDIF
+  
+  END SUBROUTINE check_buffer_r
+  
+  SUBROUTINE check_buffer_l(buff_size)
+  IMPLICIT NONE
+  INTEGER :: buff_size
+
+    IF (buff_size>size_l) THEN
+!$OMP BARRIER
+!$OMP MASTER
+      IF (ALLOCATED(buffer_l)) DEALLOCATE(buffer_l)
+      size_l=MAX(size_min,INT(grow_factor*buff_size))
+      ALLOCATE(buffer_l(size_l))
+!$OMP END MASTER
+!$OMP BARRIER
+    ENDIF
+  
+  END SUBROUTINE check_buffer_l
+    
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !! Definition des Broadcast --> 4D   !!
@@ -44,6 +109,6 @@
   IMPLICIT NONE
     CHARACTER(LEN=*),INTENT(INOUT) :: Var
-
-    CALL bcast_omp_cgen(Var,len(Var),omp_buffer)
+    
+    CALL bcast_omp_cgen(Var,len(Var),buffer_c)
     
   END SUBROUTINE bcast_omp_c
@@ -54,6 +119,10 @@
   IMPLICIT NONE
     INTEGER,INTENT(INOUT) :: Var
-
-    CALL bcast_omp_igen(Var,1,omp_buffer)
+    INTEGER :: Var_tmp(1)
+    
+    Var_tmp(1)=Var
+    CALL check_buffer_i(1)
+    CALL bcast_omp_igen(Var_tmp,1,buffer_i)
+    Var=Var_tmp(1)
 
   END SUBROUTINE bcast_omp_i
@@ -64,5 +133,6 @@
     INTEGER,INTENT(INOUT) :: Var(:)
    
-    CALL bcast_omp_igen(Var,size(Var),omp_buffer)
+    CALL check_buffer_i(size(Var))
+    CALL bcast_omp_igen(Var,size(Var),buffer_i)
 
   END SUBROUTINE bcast_omp_i1
@@ -73,5 +143,6 @@
     INTEGER,INTENT(INOUT) :: Var(:,:)
    
-    CALL bcast_omp_igen(Var,size(Var),omp_buffer)
+    CALL check_buffer_i(size(Var))
+    CALL bcast_omp_igen(Var,size(Var),buffer_i)
 
   END SUBROUTINE bcast_omp_i2
@@ -82,5 +153,6 @@
     INTEGER,INTENT(INOUT) :: Var(:,:,:)
 
-    CALL bcast_omp_igen(Var,size(Var),omp_buffer)
+    CALL check_buffer_i(size(Var))
+    CALL bcast_omp_igen(Var,size(Var),buffer_i)
 
   END SUBROUTINE bcast_omp_i3
@@ -91,5 +163,6 @@
     INTEGER,INTENT(INOUT) :: Var(:,:,:,:)
    
-    CALL bcast_omp_igen(Var,size(Var),omp_buffer)
+    CALL check_buffer_i(size(Var))
+    CALL bcast_omp_igen(Var,size(Var),buffer_i)
 
   END SUBROUTINE bcast_omp_i4
@@ -101,6 +174,10 @@
   IMPLICIT NONE
     REAL,INTENT(INOUT) :: Var
-
-    CALL bcast_omp_rgen(Var,1,omp_buffer)
+    REAL :: Var_tmp(1)
+    
+    Var_tmp(1)=Var
+    CALL check_buffer_r(1)
+    CALL bcast_omp_rgen(Var_tmp,1,buffer_r)
+    Var=Var_tmp(1)
 
   END SUBROUTINE bcast_omp_r
@@ -111,5 +188,6 @@
     REAL,INTENT(INOUT) :: Var(:)
    
-    CALL bcast_omp_rgen(Var,size(Var),omp_buffer)
+    CALL check_buffer_r(size(Var))
+    CALL bcast_omp_rgen(Var,size(Var),buffer_r)
 
   END SUBROUTINE bcast_omp_r1
@@ -120,5 +198,6 @@
     REAL,INTENT(INOUT) :: Var(:,:)
    
-    CALL bcast_omp_rgen(Var,size(Var),omp_buffer)
+    CALL check_buffer_r(size(Var))
+    CALL bcast_omp_rgen(Var,size(Var),buffer_r)
 
   END SUBROUTINE bcast_omp_r2
@@ -129,5 +208,6 @@
     REAL,INTENT(INOUT) :: Var(:,:,:)
 
-    CALL bcast_omp_igen(Var,size(Var),omp_buffer)
+    CALL check_buffer_r(size(Var))
+    CALL bcast_omp_rgen(Var,size(Var),buffer_r)
 
   END SUBROUTINE bcast_omp_r3
@@ -138,5 +218,6 @@
     REAL,INTENT(INOUT) :: Var(:,:,:,:)
    
-    CALL bcast_omp_rgen(Var,size(Var),omp_buffer)
+    CALL check_buffer_r(size(Var))
+    CALL bcast_omp_rgen(Var,size(Var),buffer_r)
 
   END SUBROUTINE bcast_omp_r4
@@ -148,6 +229,10 @@
   IMPLICIT NONE
     LOGICAL,INTENT(INOUT) :: Var
-
-    CALL bcast_omp_lgen(Var,1,omp_buffer)
+    LOGICAL :: Var_tmp(1)
+    
+    Var_tmp(1)=Var
+    CALL check_buffer_l(1)
+    CALL bcast_omp_lgen(Var_tmp,1,buffer_l)
+    Var=Var_tmp(1)
 
   END SUBROUTINE bcast_omp_l
@@ -158,5 +243,6 @@
     LOGICAL,INTENT(INOUT) :: Var(:)
    
-    CALL bcast_omp_lgen(Var,size(Var),omp_buffer)
+    CALL check_buffer_l(size(Var))
+    CALL bcast_omp_lgen(Var,size(Var),buffer_l)
 
   END SUBROUTINE bcast_omp_l1
@@ -167,5 +253,6 @@
     LOGICAL,INTENT(INOUT) :: Var(:,:)
    
-    CALL bcast_omp_lgen(Var,size(Var),omp_buffer)
+    CALL check_buffer_l(size(Var))
+    CALL bcast_omp_lgen(Var,size(Var),buffer_l)
 
   END SUBROUTINE bcast_omp_l2
@@ -176,5 +263,6 @@
     LOGICAL,INTENT(INOUT) :: Var(:,:,:)
 
-    CALL bcast_omp_lgen(Var,size(Var),omp_buffer)
+    CALL check_buffer_l(size(Var))
+    CALL bcast_omp_lgen(Var,size(Var),buffer_l)
 
   END SUBROUTINE bcast_omp_l3
@@ -185,5 +273,6 @@
     LOGICAL,INTENT(INOUT) :: Var(:,:,:,:)
    
-    CALL bcast_omp_lgen(Var,size(Var),omp_buffer)
+    CALL check_buffer_l(size(Var))
+    CALL bcast_omp_lgen(Var,size(Var),buffer_l)
 
   END SUBROUTINE bcast_omp_l4
@@ -196,5 +285,4 @@
 
   SUBROUTINE scatter_omp_i(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -202,12 +290,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
 
-    INTEGER :: dummy
-
-
-     IF (is_omp_root) THEN
-      CALL scatter_omp_igen(VarIn,Varout,1,omp_buffer)
-     ELSE
-      CALL scatter_omp_igen(dummy,Varout,1,omp_buffer)
-    ENDIF
+    CALL Check_buffer_i(size(VarIn))   
+    CALL scatter_omp_igen(VarIn,Varout,1,buffer_i)
     
   END SUBROUTINE scatter_omp_i
@@ -215,17 +297,11 @@
 
   SUBROUTINE scatter_omp_i1(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
     INTEGER,INTENT(IN),DIMENSION(:,:) :: VarIn
     INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
-    
-    INTEGER :: dummy
-
-    IF (is_omp_root) THEN
-      CALL scatter_omp_igen(VarIn,Varout,Size(VarOut,2),omp_buffer)
-    ELSE
-      CALL scatter_omp_igen(dummy,Varout,Size(VarOut,2),omp_buffer)
-    ENDIF
+
+    CALL Check_buffer_i(size(VarIn))   
+    CALL scatter_omp_igen(VarIn,Varout,Size(VarOut,2),buffer_i)
     
   END SUBROUTINE scatter_omp_i1
@@ -233,5 +309,4 @@
   
   SUBROUTINE scatter_omp_i2(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -239,11 +314,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    INTEGER :: dummy
-    
-    IF (is_omp_root) THEN
-      CALL scatter_omp_igen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3),omp_buffer)
-    ELSE
-      CALL scatter_omp_igen(dummy,Varout,Size(VarOut,2)*Size(VarOut,3),omp_buffer)
-    ENDIF
+    CALL Check_buffer_i(size(VarIn))   
+    CALL scatter_omp_igen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3),buffer_i)
 
   END SUBROUTINE scatter_omp_i2
@@ -251,5 +321,4 @@
 
   SUBROUTINE scatter_omp_i3(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -257,11 +326,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    INTEGER :: dummy
-    
-    IF (is_omp_root) THEN
-      CALL scatter_omp_igen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),omp_buffer)
-    ELSE
-      CALL scatter_omp_igen(dummy,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),omp_buffer)
-    ENDIF
+    CALL Check_buffer_i(size(VarIn))   
+    CALL scatter_omp_igen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),buffer_i)
   
   END SUBROUTINE scatter_omp_i3
@@ -271,5 +335,4 @@
 
   SUBROUTINE scatter_omp_r(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -277,12 +340,6 @@
     REAL,INTENT(OUT),DIMENSION(:) :: VarOut
 
-    REAL :: dummy
-
-
-     IF (is_omp_root) THEN
-      CALL scatter_omp_rgen(VarIn,Varout,1,omp_buffer)
-     ELSE
-      CALL scatter_omp_rgen(dummy,Varout,1,omp_buffer)
-    ENDIF
+    CALL Check_buffer_r(size(VarIn))   
+    CALL scatter_omp_rgen(VarIn,Varout,1,buffer_r)
     
   END SUBROUTINE scatter_omp_r
@@ -290,5 +347,4 @@
 
   SUBROUTINE scatter_omp_r1(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -296,17 +352,11 @@
     REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    REAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL scatter_omp_rgen(VarIn,Varout,Size(VarOut,2),omp_buffer)
-    ELSE
-      CALL scatter_omp_rgen(dummy,Varout,Size(VarOut,2),omp_buffer)
-    ENDIF
-    
+    CALL Check_buffer_r(size(VarIn))   
+    CALL scatter_omp_rgen(VarIn,Varout,Size(VarOut,2),buffer_r)
+        
   END SUBROUTINE scatter_omp_r1
   
   
   SUBROUTINE scatter_omp_r2(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -314,11 +364,6 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    REAL :: dummy
-    
-    IF (is_omp_root) THEN
-      CALL scatter_omp_rgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3),omp_buffer)
-    ELSE
-      CALL scatter_omp_rgen(dummy,Varout,Size(VarOut,2)*Size(VarOut,3),omp_buffer)
-    ENDIF
+    CALL Check_buffer_r(size(VarIn))   
+    CALL scatter_omp_rgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3),buffer_r)
 
   END SUBROUTINE scatter_omp_r2
@@ -326,5 +371,4 @@
 
   SUBROUTINE scatter_omp_r3(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -332,11 +376,6 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    REAL :: dummy
-    
-    IF (is_omp_root) THEN
-      CALL scatter_omp_rgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),omp_buffer)
-    ELSE
-      CALL scatter_omp_rgen(dummy,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),omp_buffer)
-    ENDIF
+    CALL Check_buffer_r(size(VarIn))   
+    CALL scatter_omp_rgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),buffer_r)
   
   END SUBROUTINE scatter_omp_r3
@@ -345,5 +384,4 @@
 
   SUBROUTINE scatter_omp_l(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -351,12 +389,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:) :: VarOut
 
-    LOGICAL :: dummy
-
-
-     IF (is_omp_root) THEN
-      CALL scatter_omp_lgen(VarIn,Varout,1,omp_buffer)
-     ELSE
-      CALL scatter_omp_lgen(dummy,Varout,1,omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarIn))   
+    CALL scatter_omp_lgen(VarIn,Varout,1,buffer_l)
     
   END SUBROUTINE scatter_omp_l
@@ -364,5 +396,4 @@
 
   SUBROUTINE scatter_omp_l1(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -370,11 +401,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    LOGICAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL scatter_omp_lgen(VarIn,Varout,Size(VarOut,2),omp_buffer)
-    ELSE
-      CALL scatter_omp_lgen(dummy,Varout,Size(VarOut,2),omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarIn))   
+    CALL scatter_omp_lgen(VarIn,Varout,Size(VarOut,2),buffer_l)
     
   END SUBROUTINE scatter_omp_l1
@@ -382,5 +408,4 @@
   
   SUBROUTINE scatter_omp_l2(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -388,11 +413,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    LOGICAL :: dummy
-    
-    IF (is_omp_root) THEN
-      CALL scatter_omp_lgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3),omp_buffer)
-    ELSE
-      CALL scatter_omp_lgen(dummy,Varout,Size(VarOut,2)*Size(VarOut,3),omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarIn))   
+    CALL scatter_omp_lgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3),buffer_l)
 
   END SUBROUTINE scatter_omp_l2
@@ -400,5 +420,4 @@
 
   SUBROUTINE scatter_omp_l3(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -406,11 +425,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    LOGICAL :: dummy
-    
-    IF (is_omp_root) THEN
-      CALL scatter_omp_lgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),omp_buffer)
-    ELSE
-      CALL scatter_omp_lgen(dummy,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarIn))   
+    CALL scatter_omp_lgen(VarIn,Varout,Size(VarOut,2)*Size(VarOut,3)*Size(VarOut,4),buffer_l)
   
   END SUBROUTINE scatter_omp_l3  
@@ -418,5 +432,4 @@
 
   SUBROUTINE gather_omp_i(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -424,12 +437,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
 
-    INTEGER :: dummy
-
-
-     IF (is_omp_root) THEN
-      CALL gather_omp_igen(VarIn,Varout,1,omp_buffer)
-     ELSE
-      CALL gather_omp_igen(dummy,Varout,1,omp_buffer)
-    ENDIF
+    CALL Check_buffer_i(size(VarOut))   
+    CALL gather_omp_igen(VarIn,Varout,1,buffer_i)
     
   END SUBROUTINE gather_omp_i
@@ -437,5 +444,4 @@
 
   SUBROUTINE gather_omp_i1(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -443,11 +449,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    INTEGER :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_igen(VarIn,Varout,Size(VarIn,2),omp_buffer)
-    ELSE
-      CALL gather_omp_igen(VarIn,dummy,Size(VarIn,2),omp_buffer)
-    ENDIF
+    CALL Check_buffer_i(size(VarOut))   
+    CALL gather_omp_igen(VarIn,Varout,Size(VarIn,2),buffer_i)
     
   END SUBROUTINE gather_omp_i1
@@ -455,5 +456,4 @@
 
   SUBROUTINE gather_omp_i2(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -461,17 +461,11 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    INTEGER :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_igen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3),omp_buffer)
-    ELSE
-      CALL gather_omp_igen(VarIn,dummy,Size(VarIn,2)*Size(VarIn,3),omp_buffer)
-    ENDIF
-    
+    CALL Check_buffer_i(size(VarOut))   
+    CALL gather_omp_igen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3),buffer_i)
+          
   END SUBROUTINE gather_omp_i2
   
 
   SUBROUTINE gather_omp_i3(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -479,11 +473,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    INTEGER :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_igen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),omp_buffer)
-    ELSE
-      CALL gather_omp_igen(VarIn,dummy,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),omp_buffer)
-    ENDIF
+    CALL Check_buffer_i(size(VarOut))   
+    CALL gather_omp_igen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),buffer_i)
     
   END SUBROUTINE gather_omp_i3
@@ -492,5 +481,4 @@
 
   SUBROUTINE gather_omp_r(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -498,12 +486,6 @@
     REAL,INTENT(OUT),DIMENSION(:) :: VarOut
 
-    REAL :: dummy
-
-
-     IF (is_omp_root) THEN
-      CALL gather_omp_rgen(VarIn,Varout,1,omp_buffer)
-     ELSE
-      CALL gather_omp_rgen(VarIn,dummy,1,omp_buffer)
-    ENDIF
+    CALL Check_buffer_r(size(VarOut))   
+    CALL gather_omp_rgen(VarIn,Varout,1,buffer_r)
     
   END SUBROUTINE gather_omp_r
@@ -511,23 +493,16 @@
 
   SUBROUTINE gather_omp_r1(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
     REAL,INTENT(IN),DIMENSION(:,:) :: VarIn
     REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
-    
-    REAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_rgen(VarIn,Varout,Size(VarIn,2),omp_buffer)
-    ELSE
-      CALL gather_omp_rgen(VarIn,dummy,Size(VarIn,2),omp_buffer)
-    ENDIF
-    
+
+    CALL Check_buffer_r(size(VarOut))   
+    CALL gather_omp_rgen(VarIn,Varout,Size(VarIn,2),buffer_r)
+        
   END SUBROUTINE gather_omp_r1
 
 
   SUBROUTINE gather_omp_r2(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -535,11 +510,6 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    REAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_rgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3),omp_buffer)
-    ELSE
-      CALL gather_omp_rgen(VarIn,dummy,Size(VarIn,2)*Size(VarIn,3),omp_buffer)
-    ENDIF
+    CALL Check_buffer_r(size(VarOut))   
+    CALL gather_omp_rgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3),buffer_r)
     
   END SUBROUTINE gather_omp_r2
@@ -547,5 +517,4 @@
 
   SUBROUTINE gather_omp_r3(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -553,11 +522,5 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    REAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_rgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),omp_buffer)
-    ELSE
-      CALL gather_omp_rgen(VarIn,dummy,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),omp_buffer)
-    ENDIF
+    CALL gather_omp_rgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),buffer_r)
     
   END SUBROUTINE gather_omp_r3
@@ -565,5 +528,4 @@
 
   SUBROUTINE gather_omp_l(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -571,12 +533,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:) :: VarOut
 
-    LOGICAL :: dummy
-
-
-     IF (is_omp_root) THEN
-      CALL gather_omp_lgen(VarIn,Varout,1,omp_buffer)
-     ELSE
-      CALL gather_omp_lgen(VarIn,dummy,1,omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarOut))   
+    CALL gather_omp_lgen(VarIn,Varout,1,buffer_l)
     
   END SUBROUTINE gather_omp_l
@@ -584,5 +540,4 @@
 
   SUBROUTINE gather_omp_l1(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -590,11 +545,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    LOGICAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_lgen(VarIn,Varout,Size(VarIn,2),omp_buffer)
-    ELSE
-      CALL gather_omp_lgen(VarIn,dummy,Size(VarIn,2),omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarOut))   
+    CALL gather_omp_lgen(VarIn,Varout,Size(VarIn,2),buffer_l)
     
   END SUBROUTINE gather_omp_l1
@@ -602,5 +552,4 @@
 
   SUBROUTINE gather_omp_l2(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -608,11 +557,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    LOGICAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_lgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3),omp_buffer)
-    ELSE
-      CALL gather_omp_lgen(VarIn,dummy,Size(VarIn,2)*Size(VarIn,3),omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarOut))   
+    CALL gather_omp_lgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3),buffer_l)
     
   END SUBROUTINE gather_omp_l2
@@ -620,5 +564,4 @@
 
   SUBROUTINE gather_omp_l3(VarIn, VarOut)
-    USE mod_phys_lmdz_omp_data, ONLY : is_omp_root
     IMPLICIT NONE
   
@@ -626,11 +569,6 @@
     LOGICAL,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
     
-    LOGICAL :: dummy
-
-    IF (is_omp_root) THEN
-      CALL gather_omp_lgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),omp_buffer)
-    ELSE
-      CALL gather_omp_lgen(VarIn,dummy,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),omp_buffer)
-    ENDIF
+    CALL Check_buffer_l(size(VarOut))   
+    CALL gather_omp_lgen(VarIn,Varout,Size(VarIn,2)*Size(VarIn,3)*Size(VarIn,4),buffer_l)
     
   END SUBROUTINE gather_omp_l3
@@ -644,7 +582,12 @@
     INTEGER,INTENT(IN)  :: VarIn
     INTEGER,INTENT(OUT) :: VarOut
-    
-    CALL reduce_sum_omp_igen(VarIn,Varout,1,omp_buffer)
-  
+    INTEGER             :: VarIn_tmp(1)
+    INTEGER             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_i(1)   
+    CALL reduce_sum_omp_igen(VarIn_tmp,Varout_tmp,1,buffer_i)
+    VarOut=VarOut_tmp(1)
+    
   END SUBROUTINE reduce_sum_omp_i
 
@@ -655,5 +598,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:) :: VarOut
     
-    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),omp_buffer)
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
    
   END SUBROUTINE reduce_sum_omp_i1
@@ -665,6 +609,7 @@
     INTEGER,INTENT(IN),DIMENSION(:,:)  :: VarIn
     INTEGER,INTENT(OUT),DIMENSION(:,:) :: VarOut
-    
-    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),omp_buffer)
+
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
   
   END SUBROUTINE reduce_sum_omp_i2
@@ -677,5 +622,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),omp_buffer)
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
   
   END SUBROUTINE reduce_sum_omp_i3
@@ -688,5 +634,6 @@
     INTEGER,INTENT(OUT),DIMENSION(:,:,:,:) :: VarOut
   
-    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),omp_buffer)
+    CALL Check_buffer_i(size(VarIn))   
+    CALL reduce_sum_omp_igen(VarIn,Varout,Size(VarIn),buffer_i)
   
   END SUBROUTINE reduce_sum_omp_i4
@@ -698,6 +645,11 @@
     REAL,INTENT(IN)  :: VarIn
     REAL,INTENT(OUT) :: VarOut
-    
-    CALL reduce_sum_omp_rgen(VarIn,Varout,1,omp_buffer)
+    REAL             :: VarIn_tmp(1)
+    REAL             :: VarOut_tmp(1)
+    
+    VarIn_tmp(1)=VarIn
+    CALL Check_buffer_r(1)   
+    CALL reduce_sum_omp_rgen(VarIn_tmp,Varout_tmp,1,buffer_r)
+    VarOut=VarOut_tmp(1)
   
   END SUBROUTINE reduce_sum_omp_r
@@ -709,5 +661,6 @@
     REAL,INTENT(OUT),DIMENSION(:) :: VarOut
     
-    CALL reduce_sum_omp_rgen(VarIn,Varout,Size(VarIn),omp_buffer)
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_sum_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
    
   END SUBROUTINE reduce_sum_omp_r1
@@ -720,5 +673,6 @@
     REAL,INTENT(OUT),DIMENSION(:,:) :: VarOut
     
-    CALL reduce_sum_omp_rgen(VarIn,Varout,Size(VarIn),omp_buffer)
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_sum_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
   
   END SUBROUTINE reduce_sum_omp_r2
@@ -731,5 +685,6 @@
     REAL,INTENT(OUT),DIMENSION(:,:,:) :: VarOut
     
-    CALL reduce_sum_omp_rgen(VarIn,Varout,Size(VarIn),omp_buffer)
+    CALL Check_buffer_r(size(VarIn))   
+    CALL reduce_sum_omp_rgen(VarIn,Varout,Size(VarIn),buffer_r)
   
   END SUBROUTINE reduce_sum_omp_r3
